#ifndef __THREAD_ALLOC_H__
#define __THREAD_ALLOC_H__

#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

void* thread_alloc(size_t size);
void* thread_realloc(void* addr, size_t size);
void  thread_free(void* addr);

#ifdef __cplusplus
}

#include <new>

#ifdef REDEFINE_DEFAULT_NEW_OPERATOR

void *operator new(size_t size) throw(std::bad_alloc) { return thread_alloc(size); }
void operator delete(void* addr) throw() { thread_free(addr); }

#if __DECCXX_VER >= 60390000
void *operator new[](size_t size) throw(std::bad_alloc) { return thread_alloc(size); }
void operator delete[](void* addr) throw() { thread_free(addr); }

// Entry point into C++ Class Library
#ifdef __MODEL_ANSI
extern "C" void *__7__nw__FUl(size_t size) {
#else  //__MODEL_ARM
extern "C" void *__nw__XUl(size_t size) {
#endif
	return ::operator new(size);
}
#endif

#endif

#endif

#endif

